/*******************************************************************
Valkanas GIwrgos
AM: 018200200003
POLA v2.0
Prosomoiwsh poker
*******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define num_of_players 2
#define num_of_cards 5

#include "help.h"
#include "pola v2.0.h"
#include "has_what.h"
#include "print_cards.h"

int main()
{
	int i, counter = 1, count_temp;
	short int pl_hand_lvl[num_of_players];
	hand player[num_of_players];
	int trapoula[13][4];

	srand(time(NULL));

	pola();

	/* anakatema ths trapoulas */
	anakatema(trapoula);
	
	for(i=0; i < num_of_cards * num_of_players ; i++)
	{
		/* Epistrefoume enallax apo ena fyllo ston kathe paixth */
		return_card(trapoula, counter, &player[(counter - 1)%num_of_players].num[i%num_of_cards], &player[(counter - 1)%num_of_players].design[i%num_of_cards]);
		counter++;
	}

	/* Taksinomisi tou xeriou twn paixtwn gia diefkolinsi mas */
	for (i=0; i< num_of_players; i++)
		bubblesort(&player[i]);

	/* Enhmerwnoume ton paixth gia ta fyla pou exei sto xeri tou */
	printf("\nSTO XERI SOY EXEIS TA EKSHS FYLA:\n");
	printf("- h POLA den kserei ta fyla sou, oute esy ta dika ths -\n");
	print_hand(player[1], num_of_cards);

	/* Vriskoume to epipedo twn fyllwn pou exei o kathe paixths */
	for (i=0; i<num_of_players; i++)
		pl_hand_lvl[i] = return_hand_lvl(player[i]);

	/* Enhmerwnoume to xrhsth gia to epipedo twn fylwn pou exei */
	printf("\nPOLA: Exeis ");
	if ( has_what(pl_hand_lvl[1], player[1]) == -1)
		printf("kako fylo!!!");

	printf("\n");

	count_temp = counter;

	/* H "eksypnh pola" allazei kai ta dika ths fyla */
	clever_pola(&player[0], &counter, trapoula, pl_hand_lvl[0]);
	
	/* An h POLA allakse kapoio fyllo */
	if (counter != count_temp)
	{
		/* Enhmerwnoume to xrhsth gia to posa fylla exei allaksei h POLA */
		printf("\n - Vlepeis oti h pola allakse %d ", counter - count_temp);
		if ( (counter - count_temp) == 1 )
			printf("fylo -");
		else
			printf("fyla -");
		/* Taksinomoume kai pali ta fylla ths POLA */
		bubblesort(&player[0]);
		
		/* Vriskoume to epipedo twn fyllwn pou exei h POLA, afou allakse ta fylla ths */
		pl_hand_lvl[0] = return_hand_lvl(player[0]);
		count_temp = counter;
	}

	printf("\n");

	/* Kaleitai h synartisi gia thn allagh twn fylwn tou paixth */
	change_cards(&player[1], &counter, trapoula);

	/* O paixths exei allaksei ta fyla tou */
	if (counter != count_temp)
	{
		/* Taksinomisi twn fylwn tou paixth afou allakse ta fylla tou*/
		bubblesort(&player[1]);

		/* Eksetazoume ta kainouria fyla tou paixth */
		pl_hand_lvl[1] = return_hand_lvl(player[1]);
		
		printf("\nPOLA: Exeis ");
		if ( has_what(pl_hand_lvl[1], player[1]) == -1)
			printf("kako fylo!!!");
	}

	printf("\n");

	/* Typwnoume ta fyla pou exoun oi dyo paixtes */
	printf("\nPOLA: STO XERI MOY EXW\n");
	print_hand(player[0], num_of_cards);
	printf("\nPOLA: Exw ");
		if ( has_what(pl_hand_lvl[0], player[0]) == -1)
			printf("kako fylo!!!");
	

	printf("\n");

	printf("\nPOLA: ESY EXEIS\n");
	print_hand(player[1], num_of_cards);
	printf("\nPOLA: Exeis ");
		if ( has_what(pl_hand_lvl[1], player[1]) == -1)
			printf("kako fylo!!!");

	printf("\n");
	
	if (pl_hand_lvl[1] > pl_hand_lvl[0])
	{
		printf("\n");
		printf("POLA: NIKHSES! EXEIS KALYTERO XARTI APO MENA!!!\n");
		printf("POLA: SYGXARITHRIA!!!");
	}
	else
		if (pl_hand_lvl[1] < pl_hand_lvl[0])
		{
			printf("\n");
			printf("POLA: EXASES. EXW KALYTERO XARTI APO SENA.\n");
			printf("POLA: ISWS EISAI PIO TYXEROS THN EPOMENH FORA!!!");
		}



	printf("\n\n");
	getchar();
	return 0;
}


hand_lvl return_hand_lvl(hand player)
{
	if ( flos(player.design) != -1 )
			return flosh;
		else
			if ( kare(player.num) != -1 )
				return  karre;
			else
				if ( foul(player.num) != -1 )
					return fool;
				else
					if ( kenta(player.num) != -1 )
						return keda;
					else
						if ( dyo_zevgaria(player.num) != -1 )
							return two_pairs;
						else
							if ( triari(player.num) != -1 )
								return three;
							else
								if (zevgari(player.num) != -1)
									return pair;
								else
									return -1;
}


/* Synartisi gia thn allagh twn fylwn tou groupierh! */
void clever_pola(hand *pola, int *counter, int trapoula[][4], int pola_level)
{
	switch (pola_level)
	{
		/*  An exeis hdh kapoio kalo fyllo, h kati pou de mporei na se odhghsei se kalytero
		mhn allazeis to xeri sou (to default prepei na ftiaxtei) */
		default:
		case keda:
		case fool:
		case flosh:
		case karre:
			break;
		case two_pairs:		// Exei dyo zevgaria, opote allazei to trito fyllo pou einai asxeto
			if ( dyo_zevgaria(pola->num) == 0 )	// An to prwto zevgari einai ta 2 prwta fylla...
				if ( pola->num[2] == pola->num[3] )		//....kai to 2o to 3o & to 4o fyllo....
					return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );	// allakse to 5o fyllo!
				else		//....enw an to 2o zevgari einai to 4o kai to 5o fyllo...
					return_card( trapoula, *counter, &(pola->num[2]), &(pola->design[2]) );	// allakse to 3o fyllo!
			else	//...enw an to prwto zevgari einai to 2o kai to 3o fyllo...
				return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );	// allakse to 1o fyllo!
			(*counter)++;
			break;
		case three:		/* H POLA exei triari */
			if (triari(pola->num) == 0 )	/* An to triari ksekinaei to 1o fyllo */
			{
				/* Allakse to 4o kai to 5o fyllo */
				return_card( trapoula, *counter, &(pola->num[3]), &(pola->design[3]) );
				(*counter)++;
				return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );
			}
			else
				/* an to triari ksekinaei apo to 2o fyllo... */
				if ( triari(pola->num) == 1 ) 
				{
					/* allakse to 1o kai to teleftaio fyllo */
					return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );
					(*counter)++;
					return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );
				}
				else
				{
					/* enw an to triari ksekinaei apo to 3o fyllo kai meta, allakse ta 2 prwta */
					return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );
					(*counter)++;
					return_card( trapoula, *counter, &(pola->num[1]), &(pola->design[1]) );
				}
			(*counter)++;
			break;
		case pair:
			/* Otan exei zevgari , allazei ta 3 alla fylla pou den einai zevgari */
			if ( zevgari(pola->num) == 0 )
			{
				return_card( trapoula, *counter, &(pola->num[2]), &(pola->design[2]) );
				(*counter)++;
				return_card( trapoula, *counter, &(pola->num[3]), &(pola->design[3]) );
				(*counter)++;				
				return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );
			}
			else
				if (zevgari(pola->num) == 1)
				{
					return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );
					(*counter)++;
					return_card( trapoula, *counter, &(pola->num[3]), &(pola->design[3]) );
					(*counter)++;				
					return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );
				}
				else
					if (zevgari(pola->num) == 2)
					{
						return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );
						(*counter)++;
						return_card( trapoula, *counter, &(pola->num[1]), &(pola->design[1]) );
						(*counter)++;				
						return_card( trapoula, *counter, &(pola->num[4]), &(pola->design[4]) );
					}
					else
					{
						return_card( trapoula, *counter, &(pola->num[0]), &(pola->design[0]) );
						(*counter)++;
						return_card( trapoula, *counter, &(pola->num[1]), &(pola->design[1]) );
						(*counter)++;				
						return_card( trapoula, *counter, &(pola->num[2]), &(pola->design[2]) );
					}
			(*counter)++;
			break;
	}
}


/* Synartisi gia thn allagh twn fylwn tou paixth */
void change_cards(hand *player, int *counter, int trapoula[][4])
{
	char c;
	int problem;
	int i, j, change_num, change_table[3];

	/* Rwtame ton paixth posa fyla thelei na allaksei */
	printf("\nPOLA: THELETE NA ALLAKSETE TA FYLA SAS? (y/n): ");
	c = getchar();
	fflush(stdin);

	/* O paixths prepei na apanthsei n h oxi, alliws h apanthsh tou de ginetai dekth */
	while ( c!= 'y' && c!= 'n' && c!= 'Y' && c!= 'N' )
	{
		printf("\n");
		printf("POLA: LYPAMAI. DEN KATALABAINW TI MOU ZHTATE.\n");
		printf("POLA: GIA NA ALLAKSETE TA FYLA SAS, PATHSTE TO GRAMMA y.\n");
		printf("POLA: GIA NA SYNEXISETE ME TA FYLA POU EXETE, PATHSTE TO GRAMMA n. ");
		c = getchar();
		fflush(stdin);
	}

	/* O paixths zhthse thn allagh twn fylwn tou */
	if (c == 'y' || c == 'Y')
	{
		printf("\n");
		printf("POLA: POSA FYLA THELETE NA ALLAKSETE? (MAXIMUM 3): ");
		scanf("%d", &change_num);
		fflush(stdin);

		while (change_num < 0 || change_num > 3)
		{
			printf("\n");
			printf("POLA: LYPAMAI. DE MPOREITE NA ALLAKSETE TOSA FYLA.\n");
			printf("POLA: POSA FYLA THELETE NA ALLAKSETE? (MAXIMUM 3): ");
			scanf("%d", &change_num);
			fflush(stdin);
		}

		if (change_num != 0)
		{
			printf("\n");
			printf("POLA: TA FYLA SAS EINAI ARITHMHMENA 1-5 APO TA ARISTERA PROS TA DEKSIA.\n");
			printf("POLA: EPILEKSTE TA FYLA GIA ALLAGH APO TON ARITHMO TOY FYLOY (1-5).\n");
		}
		
		for (i=0; i< change_num; i++)
		{
			printf("\nPOLA: POIO EINAI TO %do FYLO POY THELETE NA ALLAKSETE? ", i+1);
			scanf("%d", &change_table[i]);
			fflush(stdin);
		
			do
			{
				j = 0;
				problem = 0;
				while(j<i)
				{
					if (change_table[i] == change_table[j])
					{
						printf("\nPOLA: DE MPOREITE NA ALLAKSETE TO IDIO FYLO 2 FORES!");
						printf("\nPOLA: PARAKALW DHLWSTE KAPOIO ALLO FYLO GIA ALLAGH. EFXARISTW!");
						printf("\nPOLA: POIO EINAI TO %do FYLO POY THELETE NA ALLAKSETE? ", i+1);
						scanf("%d", &change_table[i]);
						fflush(stdin);
						problem++;
						j=-1;
					}
					j++;
				}
				
				while ( change_table[i]<1 || change_table[i] > 5)
				{
					printf("\nPOLA: LYPAMAI. DEN YPARXEI TETOIO FYLO.");
					printf("\nPOLA: TA FYLA SAS EINAI ARITHMHMENA 1-5 APO TA ARISTERA PROS TA DEKSIA.");
					printf("\nPOLA: EPILEKSTE TA FYLA GIA ALLAGH APO TON ARITHMO TOY FYLOY (1-5).");
					printf("\nPOLA: POIO EINAI TO %do FYLO POY THELETE NA ALLAKSETE? ", i+1);
					scanf("%d", &change_table[i]);
					problem++;
					fflush(stdin);
				}

			}while(problem);

			return_card(trapoula, *counter, &(player->num[change_table[i]-1]), &(player->design[change_table[i]-1]) );
			(*counter)++;
		}
	}
}

int return_card(int trapoula[][4], int counter, int *num, int *design)
{
	int i, j;

	for (i=0; i<13; i++)
		for (j=0; j<4; j++)
			if (trapoula[i][j] == counter)
			{
				*num = i + 1;
				*design = j + 3;
				return 0;
			}
	return 0;
}


void anakatema(int trapoula[][4])
{
	int i, j, counter;
	
	printf("POLA: MISO LEPTO NA ANAKATEPSW THN TRAPOULA!\n");
	
	/* Arxikopoihsh olwn twn thesewn ths trapoulas sto 0 (dhladh den exei kathoristei akoma h seira)*/
	for (i = 0; i < 13; i++)
		for (j = 0; j < 4; j++)
			trapoula[i][j] = 0;

	for (counter = 1; counter <= 52; counter++)
	{
		/* Vres mia tyxaia thesi tou pinaka */
		i = rand() % 13;
		j = rand() % 4;
		
		/* Oso h thesi tou pinaka pou petyxes exei hdh katalifthei apo kapoio allo stoixeio, psaxne
		gia kapoia thesi pou na mhn exei katalifthei akoma */
		while(trapoula[i][j] != 0)
		{
			i = rand() % 13;
			j = rand() % 4;
		}

		/* Dwse thn antistoixh proteraiothta sto fyllo afto */
		trapoula[i][j] = counter;
	}

	printf("\n");
	printf("POLA: H TRAPOULA ANAKATEFTIKE!\n");
	printf("POLA: MPOROUME NA KSEKINHSOYME.\n");
}

/* Synartisi pou taksinomei ta fylla tou paixth */
void bubblesort(hand *player)
{
	int i,j, temp;

	for(i=0; i<num_of_cards; i++)
		for(j=num_of_cards - 1; j>i; j--)
			if (player->num[j - 1] > player->num[j])
			{
				temp = player->num[j];
				player->num[j] = player->num[j-1];
				player->num[j-1] = temp;
				temp = player->design[j];
				player->design[j] = player->design[j-1];
				player->design[j-1] = temp;
			}
}

/* Synartisi pou ypologizei an enas paixths exei zevgari sta fylla tou */
short int zevgari(int num[])
{
	short int i, flag;

	flag = -1;

	/* Gia ola ta fylla sou.... */
	for (i=0; i<num_of_cards - 1; i++)
		if ( num[i] !=  num[i+1])		// Oso de vriskeis kapoia omoia fylla, psaxne...
			;
		else
			if (flag == -1 )	// an vreis kapoia omoia fylla kai einai h prwth fora...
				flag = i;		//... kane to flag iso me ti thesi pou vrikes ta omoia fylla!
			else
			{					//...alliws an den einai h prwth fora
				flag = -1;		//...shmainei oti o paixths exei kati kalytero apo aplo zevgari!
				break;			// de xreiazetai na psakseis ta ypoloipa fylla.
			}

	return flag;		// epestrepse afto pou vrhkes
}


/* Synartisi pou vriskei an enas paixths exei dyo zevgaria sto xeri tou */
short int dyo_zevgaria(int num[])
{
	short int flag;

	flag = -1;

	if ( (num[0] == num[1]) && (num[1] != num[2]) )
		if ( (num[2] == num[3]) && (num[3] != num[4]) )
			flag = 0;
		else
			if ( (num[2] != num[3]) && (num[3] == num[4]) )
				flag = 0;
			else
				flag = -1;
	else
		if ( num[0] != num[1])
			if ( (num[1] == num[2]) && (num[2] != num[3]) && (num[3] == num[4]) )
				flag = 1;
	return flag;
}

/* Synartisi pou vriskei an enas paixths exei triari */
short int triari(int num[])
{
	short int flag;

	flag = -1;

	/* ta tria prwta fylla na einai idia, kai ta dyo epomena na einai asxeta me ta tria prohgoumena
	alla kai metaksy tous */
	if ( (num[0] == num[1]) && (num[1] == num[2]) && (num[2] != num[3]))
		flag = 0;
	else
		/* h enallaktika, ta tria mesaia fylla na einai idia, kai to 1o kai to teleftaio na einai 
		asxeta me ta ypoloipa tria fylla */
		if ( (num[0] != num[1]) && (num[1] == num[2]) && (num[2] == num[3]) && (num[3] != num[4]) )
			flag = 1;
		else
			/* h telos, ta 2 prwta fylla na einai asxeta metaksy tous kai asxeta me ta 3 teleftaia,
			ta opoia prepei na einai omoia */
			if ( (num[1] != num[2]) && (num[2] == num[3]) && (num[3] == num[4]) )
				flag = 2;
	
	return flag;
}


/* Synartisi pou vriskei an enas paixths exei flos */
short int flos(int design[])
{
	short int flag, i;

	i = 0;
	flag = 0;

	/* an ola ta sxhmata twn fyllwn einai idia tote exei flosh */
	while( (flag != -1) && (i<4) )
	{
		if ( design[i] == design[i+1] )
			i++;
		else
			flag = -1;
	}

	return flag;
}

/* Synartisi pou vriskei an enas paixths exei kenta (5 fylla sth seira) */
short int kenta(int num[])
{
	short int flag;
	short int i;

	flag = 0;	/* Ksekiname me thn prooptikh oti o paixths exei kenta... */

	/* Kenta exei enas paixths, an gia ola ta fylla tou isxyei oti, to epomeno fyllo tou
	einai to prohgoumeno tou +1 (px 4,5,6,7,8) */
	for (i=0; i<num_of_cards - 1; i++)
		if ( (num[i] + 1) != num[i+1])	/* An gia kapoio fyllo den isxyei h sxesh, h alysida spasei*/
		{
			flag = -1;
			break;
		}

	return flag;
}

/* Synartisi pou vriskei an enas paixths exei foul */
short int foul(int num[])
{
	short int flag;

	flag = -1;

	/* An o paixths exei triari, kai ta alla dyo fylla einai isa, tote exei foul! */
	if ( (triari(num) == 0) && (num[3] == num[4]) )	
		flag = 0;
	else
		if ( (triari(num) == 2) && (num[0] == num[1]) )
			flag = 2;
		else
			flag = -1;

	return flag;

}

short int kare(int num[])
{
	short int i;
	short int flag;

	flag = -1;

	for (i=0; i<2; i++)
		/* An ta tessera fylla sth seira einai isa, tote exeis kare! */
		if ( (num[i] == num[i+1]) && (num[i+1] == num[i+2]) && (num[i+2] == num[i+3]) )
			flag = i;
	
	return flag;
}

int equal(int temp1, int temp2)
{
	return (temp1 == temp2);
}